"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createContext = void 0;
var React = require("react");
var symbolObservable_1 = require("./utils/symbolObservable");
function createUnimplemented(objectName) {
    var prefix = objectName ? objectName + "." : "";
    return function unimplemented(methodName) {
        return function () {
            throw new Error("Unimplemented method: " + prefix + methodName);
        };
    };
}
function createContext(rootReducer, preloadedState, displayName) {
    var _a;
    var unimplemented = createUnimplemented("Context(" + (displayName !== null && displayName !== void 0 ? displayName : "") + ")");
    var Context = React.createContext((_a = {
            dispatch: function (a) { return a; },
            reducer: rootReducer,
            state: preloadedState
        },
        _a[symbolObservable_1.SymbolObservable] = unimplemented(symbolObservable_1.SymbolObservable.toString()),
        _a));
    if (displayName) {
        Context.displayName = displayName;
    }
    return Context;
}
exports.createContext = createContext;
